"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CancerInterpretationRequest(ProtocolElement):
    """
    This record represents basic information for this report
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "BAMs",
        "VCFs",
        "analysisURI",
        "analysisVersion",
        "bigWigs",
        "cancerParticipant",
        "reportRequestId",
        "reportVersion",
        "versionControl",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "BAMs": reports_2_1_0.File,
            "VCFs": reports_2_1_0.File,
            "annotationFile": reports_2_1_0.File,
            "bigWigs": reports_2_1_0.File,
            "cancerParticipant": reports_2_1_0.CancerParticipant,
            "versionControl": reports_2_1_0.VersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "Gel_BioInf_Models.File": reports_2_1_0.File,
            "Gel_BioInf_Models.File": reports_2_1_0.File,
            "Gel_BioInf_Models.File": reports_2_1_0.File,
            "Gel_BioInf_Models.File": reports_2_1_0.File,
            "Gel_BioInf_Models.CancerParticipant": reports_2_1_0.CancerParticipant,
            "Gel_BioInf_Models.VersionControl": reports_2_1_0.VersionControl,
            "Gel_BioInf_Models.CancerInterpretationRequest": reports_2_1_0.CancerInterpretationRequest,
        }

    __slots__ = [
        "BAMs",
        "VCFs",
        "analysisURI",
        "analysisVersion",
        "bigWigs",
        "cancerParticipant",
        "reportRequestId",
        "reportVersion",
        "versionControl",
        "additionalInfo",
        "annotationFile",
        "interpretGenome",
    ]

    def __init__(
        self,
        BAMs,
        VCFs,
        analysisURI,
        analysisVersion,
        bigWigs,
        cancerParticipant,
        reportRequestId,
        reportVersion,
        versionControl,
        additionalInfo=None,
        annotationFile=None,
        interpretGenome=False,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_2_1_0.CancerInterpretationRequest model.

        :param BAMs:
            BAMs Files
        :type BAMs: list[File]
        :param VCFs:
            VCFs Files where SVs and CNVs are represented
        :type VCFs: list[File]
        :param analysisURI:
            Location (URI) where the data can be found
        :type analysisURI: str
        :param analysisVersion:
            GEL's analysis version for this request. It can increase if a change
            is made to the underlying data for example
        :type analysisVersion: str
        :param bigWigs:
            BigWig Files
        :type bigWigs: list[File]
        :param cancerParticipant:
        :type cancerParticipant: CancerParticipant
        :param reportRequestId:
            Unique id for this report
        :type reportRequestId: str
        :param reportVersion:
            Version of this report
        :type reportVersion: int
        :param versionControl:
            Model version number
        :type versionControl: VersionControl
        :param additionalInfo:
            Additional information
        :type additionalInfo: None | dict[str, str]
        :param annotationFile:
            This will be the output file from Cellbase + version used
        :type annotationFile: None | File
        :param interpretGenome:
            Simply load data to system or also provide interpretation?
        :type interpretGenome: boolean
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.1.0"
